{% extends 'profile/layouts/admin/admin_layout.html' %}

{% load static %}

{% block css %}
    <link rel="stylesheet" type="text/css" href="{% static 'admin/css/datatables/datatables.min.css' %}">
    <style>
        .img-bagss {
            position: absolute;
            top: 0;
            background-color: rgba(255, 0, 0, 0.8);
            text-align: center;
            font-weight: 500;
            line-height: 16px;
            padding: 5px 10px;
            color: #FFFFFF;
            border-radius: 5px 5px 5px 0;
        }
        .img-bagss .tag-bln { font-size: 15px; }
    </style>
{% endblock css %}

{% block navbar %}
    {% include 'profile/layouts/admin/navbar.html' %}
{% endblock navbar %}

{% block main %}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{% url 'profile:admin_home' %}">Home</a></li>
            <li class="breadcrumb-item active" aria-current="page">Pelayanan Pengaduan</li>
        </ol>
    </nav>

    {% if messages %}
        {% for message in messages %}
            <div class="alert {{ message.tags }} my-2" role="alert">
                {{message}}
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>  
        {% endfor %}
    {% endif %}
    
    {% for dt_kategori in kategori %}
    <button class="btn btn-info pass-data mt-2 mb-2" 
        onclick="updateUrl('kategori', '{{ dt_kategori.nama_kategori }}')">{{ dt_kategori.nama_kategori }}
    </button>
    {% endfor %}
    <button class="btn btn-warning pass-data mt-2 mb-2" 
        onclick="resetUrl()">All
    </button>

    <div class="card shadow mb-5">
        <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
            <h6 class="m-0 font-weight-bold text-info" style="flex-grow: 1;">List Pengaduan</h6>
            <div class="d-flex align-items-center position-relative my-1">
                <i id="searchIcon" class="bi bi-search fs-3 position-absolute mx-1"></i>
                <input type="text" data-kt-ecommerce-product-filter="search" class="form-control form-control-solid w-250px pl-4" placeholder="Search User" id="searchInput" />
                <div id="loadingIndicator" style="display: none; position: absolute; left: 8px; top: 50%; transform: translateY(-50%);">
                    <span class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span>
                </div>
            </div>
        </div>    

        <div class="card-body">
            <div class="table-responsive">
                <table class="table table-striped table-bordered dt-responsive">
                    <thead class="bg-info text-white">
                        <tr>
                            <th scope="col" class="text-center">No</th>
                            <th scope="col" class="text-center">Tanggal</th>
                            <th scope="col" class="text-center">N0. NIK/KTP</th>
                            <th class="text-center">Nama</th>
                            <th scope="col" class="text-center">Email</th>
                            <th scope="col" class="text-center">No. HP</th>
                            <th scope="col" class="text-center">Status</th>
                            <th scope="col" class="text-center">Nama Instansi</th>
                            <th scope="col" class="text-center">Deskripsi</th>
                            <th scope="col" class="text-center">Status Pengaduan</th>
                            <th scope="col" class="text-center">Catatan</th>
                        </tr>
                    </thead>
                    <tbody>
                        {% for dt in data_pengaduan %}
                        {% include 'profile/admin/pelayanan_pengaduan/modal.html' %}
                            <tr>
                                <td align='center'>{{ forloop.counter|add:offset }}</td>
                                <td align='center'>{{ dt.created_at }}</td>
                                <td align='center'>{{ dt.no_identitas }}</td>
                                <td align='left'>{{ dt.nama }}</td>
                                <td align='left'>{{ dt.email}}</td>
                                <td align='left'>{{ dt.no_hp}}</td>
                                <td align='left'>{{ dt.status}}</td>
                                <td align='left'>{{ dt.nama_instansi}}</td>
                                <td align='left'>{{ dt.deskripsi  | safe | truncatewords:8 }}</td>
                                {% if dt.status_pengaduan == 1 %}
                                    <td>
                                        <div class="d-flex">
                                            <a href="#" onclick="Off('{{ dt.id }}','{{ dt.tahun }}')" class="btn btn-sm btn-outline btn-outline-dashed btn-outline-success btn-active-light-success">Selesai</a>
                                            <button class="btn btn-success btn-circle pass-data mx-2" 
                                                    data-toggle="modal" data-target="#modal-view-{{dt.id}}"><i class="bi bi-eye"></i>
                                            </button> 
                                        </div> 
                                    </td>
                                {% elif dt.status_pengaduan == 0 %} 
                                    <td>
                                        <div class="d-flex">
                                            <a href="#" class="btn btn-sm btn-outline btn-outline-dashed btn-outline-danger btn-active-light-danger">Belum Selesai</a>
                                            <button class="btn btn-success btn-circle pass-data mx-2" 
                                                    data-toggle="modal" data-target="#modal-view-{{dt.id}}"><i class="bi bi-eye"></i>
                                            </button>
                                        </div>
                                    </td>
                                {% else %}
                                    <td>
                                        <div class="d-flex">
                                            <a href="#" onclick="approve_('status_pengaduan', `{{ dt.nama }}`, '{{ dt.id }}')" class="btn btn-sm btn-outline btn-outline-dashed btn-outline-warning btn-active-light-warning">Pending</a>
                                            <button class="btn btn-success btn-circle pass-data mx-2" 
                                                    data-toggle="modal" data-target="#modal-view-{{dt.id}}"><i class="bi bi-eye"></i>
                                            </button>
                                        </div>
                                    </td>
                                {% endif %}
                                <td align='left'>
                                    <div class="d-flex">
                                        {% if dt.catatan is none %}
                                            <button class="btn btn-success btn-circle pass-data mt-2 mb-2 mx-2" 
                                                data-toggle="modal" data-target="#modal-center-{{dt.id}}"><i class="bi bi-pencil"></i>
                                            </button>
                                        {% else %}
                                            {{ dt.catatan  | safe | truncatewords:8 }}
                                        {% endif %} 
                                        
                                    </div>
                                </td>
                            </tr>
                        {% endfor %}
                    </tbody>
                </table>
                <div class="col-12 d-flex justify-content-center wow slideInUp" data-wow-delay="0.1s">
                    <nav aria-label="Page navigation">
                        <ul class="pagination pagination-md m-0">
                            <!-- Tombol Previous -->
                            {% if data_pengaduan.has_previous %}
                                <li class="page-item">
                                    <a class="page-link rounded-0" href="?page={{ data_pengaduan.previous_page_number }}" aria-label="Previous">
                                        <span aria-hidden="true"><i class="bi bi-arrow-left"></i></span>
                                    </a>
                                </li>
                            {% endif %}
                
                            <!-- Halaman Pertama -->
                            <li class="page-item {% if data_pengaduan.number == 1 %}active{% endif %}">
                                <a class="page-link" href="?page=1">1</a>
                            </li>
                
                            <!-- Halaman Tengah Dinamis -->
                            {% if data_pengaduan.number > 3 %}
                                <!-- Ellipsis Sebelum -->
                                <li class="page-item disabled">
                                    <span class="page-link">...</span>
                                </li>
                            {% endif %}
                
                            {% for i in data_pengaduan.paginator.page_range %}
                                {% if i > 1 and i < data_pengaduan.paginator.num_pages %}
                                    {% if i >= data_pengaduan.number|add:-1 and i <= data_pengaduan.number|add:1 %}
                                        <li class="page-item {% if data_pengaduan.number == i %}active{% endif %}">
                                            <a class="page-link" href="?page={{ i }}">{{ i }}</a>
                                        </li>
                                    {% endif %}
                                {% endif %}
                            {% endfor %}
                
                            {% if data_pengaduan.number < data_pengaduan.paginator.num_pages|add:-2 %}
                                <!-- Ellipsis Setelah -->
                                <li class="page-item disabled">
                                    <span class="page-link">...</span>
                                </li>
                            {% endif %}
                
                            <!-- Halaman Terakhir -->
                            {% if data_pengaduan.paginator.num_pages > 1 %}
                                <li class="page-item {% if data_pengaduan.number == data_pengaduan.paginator.num_pages %}active{% endif %}">
                                    <a class="page-link" href="?page={{ data_pengaduan.paginator.num_pages }}">{{ data_pengaduan.paginator.num_pages }}</a>
                                </li>
                            {% endif %}
                
                            <!-- Tombol Next -->
                            {% if data_pengaduan.has_next %}
                                <li class="page-item">
                                    <a class="page-link rounded-0" href="?page={{ data_pengaduan.next_page_number }}" aria-label="Next">
                                        <span aria-hidden="true"><i class="bi bi-arrow-right"></i></span>
                                    </a>
                                </li>
                            {% endif %}
                        </ul>
                    </nav>
                </div>
            </div>
            
        </div>
    </div>
{% endblock main %}

{% block footer %}
    {% include 'profile/layouts/admin/footer.html' %}
{% endblock footer %}

{% block scripts_bawah %}
    <script src="{% static 'admin/js/datatables/datatables.min.js' %}"></script>
    <script src="{% static 'admin/js/admin/admin-aksi.js' %}"></script>
    <script>
        $(document).ready( function () {
            $('[data-tooltip="tooltip"]').tooltip();
            $('#table-list').DataTable();
            $('#table-archive').DataTable();
        });

        let searchParams = new URLSearchParams(window.location.search);

        function updateUrl(parameterName, parameterValue) {
            searchParams.delete(parameterName); 
            searchParams.append(parameterName, parameterValue); 
            window.location.search = searchParams.toString();
        }
        function resetUrl() {
            window.location.search = ''; 
        }

        let typingTimer; 
        const doneTypingInterval = 1000;  
        const inputElement = document.getElementById('searchInput');
        const searchIcon = document.getElementById('searchIcon');
        const loadingIndicator = document.getElementById('loadingIndicator');
        
        document.addEventListener('DOMContentLoaded', function() {
            const savedQuery = localStorage.getItem('searchQuery');
            if (savedQuery) {
                inputElement.value = savedQuery;
                setTimeout(() => {
                    inputElement.focus();
                    inputElement.setSelectionRange(inputElement.value.length, inputElement.value.length);
                }, 0);
            }
        });
        
        inputElement.addEventListener('input', function() {
            clearTimeout(typingTimer);
        
            searchIcon.style.display = 'none';
            loadingIndicator.style.display = 'block';
            
            typingTimer = setTimeout(() => {
                const query = inputElement.value.trim();
                const url = new URL(window.location.href);
                if (query) {
                    url.searchParams.set('search', query);
                } else {
                    url.searchParams.delete('search');
                }
                window.history.replaceState({}, '', url);
        
                localStorage.setItem('searchQuery', query);
        
                window.location.reload();
            }, doneTypingInterval);
        });

        function approve_(action, nama, id){
                Swal.fire({
                    title: `Konfirmasi status pegaduan atas nama ${nama}?`,
                    confirmButtonText: 'Selesai',
                    showDenyButton: true,
                    denyButtonText: 'Tidak selesai',
                    confirmButtonColor: '#198754',
                    denyButtonColor: '#d33',
                    }).then((result) => {
                    if (result.isConfirmed) {
                        $.ajax({
                            url: `${action}/${id}`,
                            data: {},
                            dataType: "html",
                            timeout: 10000,
                            beforeSend: function() {
                                Swal.fire({
                                    title: 'Memproses.........',
                                    allowEscapeKey: false,
                                    allowOutsideClick: false,
                                    showCancelButton: false,
                                    showConfirmButton: false,
                                });
                                Swal.showLoading();
                            },
                            success: function(response){
                                Swal.fire(`Pengaduan berhasil!`, '', 'success');
                                setTimeout(function(){
                                    window.location.href = "";
                                }, 2000); 
                            },
                            error: function (xhr, ajaxOptions, thrownError) {
                                Swal.fire(`Pengaduan di!`, '', 'error');
                            }
                        });
                        
                    }else if(result.isDenied){
                        $.ajax({
                            url: `belum_selesai/${id}`,
                            data: {},
                            dataType: "html",
                            timeout: 10000,
                            beforeSend: function() {
                                Swal.fire({
                                    title: 'Memproses.........',
                                    allowEscapeKey: false,
                                    allowOutsideClick: false,
                                    showCancelButton: false,
                                    showConfirmButton: false,
                                });
                                Swal.showLoading();
                            },
                            success: function(response){
                                Swal.fire(`Pengaduan tidak disetujui!`, '', 'success');
                                setTimeout(function(){
                                    window.location.href = "";
                                }, 2000); 
                            },
                            error: function (xhr, ajaxOptions, thrownError) {
                                Swal.fire(`Pengaduan tidak disetujui!`, '', 'error');
                            }
                        });
                    }else{
                        window.location.href = "";
                    }
                });

            }
    </script>
{% endblock scripts_bawah %}